]> git.madduck.net Git - code/myrepos.git/blobdiff - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

bootstrap: add support to local files
[code/myrepos.git] / mr
diff --git a/mr b/mr
index 1f01803da02f86bf0f4a48c415f15845636bd080..8601aeb422df35262239d308b18e6189b8037e6c 100755 (executable)
--- a/mr
+++ b/mr
@@ -1,8 +1,8 @@
-#!/usr/bin/perl
+#!/usr/bin/env perl
 
 =head1 NAME
 
-mr - a Multiple Repository management tool
+mr - a tool to manage all your version control repos
 
 =head1 SYNOPSIS
 
@@ -16,10 +16,18 @@ B<mr> [options] commit [-m "message"]
 
 B<mr> [options] record [-m "message"]
 
+B<mr> [options] fetch
+
+B<mr> [options] push
+
 B<mr> [options] diff
 
 B<mr> [options] log
 
+B<mr> [options] grep pattern
+
+B<mr> [options] run command [param ...]
+
 B<mr> [options] bootstrap url [directory]
 
 B<mr> [options] register [repository]
@@ -34,11 +42,11 @@ B<mr> [options] remember action [params ...]
 
 =head1 DESCRIPTION
 
-B<mr> is a Multiple Repository management tool. It can checkout, update, or
-perform other actions on a set of repositories as if they were one combined
-repository. It supports any combination of subversion, git, cvs, mercurial,
-bzr and darcs repositories, and support for other revision control systems can
-easily be added.
+B<mr> is a tool to manage all your version control repos. It can checkout,
+update, or perform other actions on a set of repositories as if they were
+one combined repository. It supports any combination of subversion, git,
+cvs, mercurial, bzr, darcs, fossil and veracity repositories, and support
+for other version control systems can easily be added.
 
 B<mr> cds into and operates on all registered repositories at or below your
 working directory. Or, if you are in a subdirectory of a repository that
@@ -47,9 +55,11 @@ and work on only that repository,
 
 B<mr> is configured by .mrconfig files, which list the repositories. It
 starts by reading the .mrconfig file in your home directory, and this can
-in turn chain load .mrconfig files from repositories.
+in turn chain load .mrconfig files from repositories. It also automatically
+looks for a .mrconfig file in the current directory, or in one of its
+parent directories.
 
-These predefined commands should be fairly familiar to users of any revision
+These predefined commands should be fairly familiar to users of any version
 control system:
 
 =over 4
@@ -67,7 +77,8 @@ If a repository isn't checked out yet, it will first check it out.
 =item status
 
 Displays a status report for each repository, showing what
-uncommitted changes are present in the repository.
+uncommitted changes are present in the repository. For distributed version
+control systems, also shows unpushed local branches.
 
 =item commit (or ci)
 
@@ -81,14 +92,20 @@ The optional -m parameter allows specifying a commit message.
 =item record
 
 Records changes to the local repository, but does not push them to the
-remote repository. Only supported for distributed revision control systems.
+remote repository. Only supported for distributed version control systems.
 
 The optional -m parameter allows specifying a commit message.
 
+=item fetch
+
+Fetches from each repository's remote repository, but does not
+update the working copy. Only supported for some distributed version
+control systems.
+
 =item push
 
 Pushes committed local changes to the remote repository. A no-op for
-centralized revision control systems.
+centralized version control systems.
 
 =item diff
 
@@ -98,6 +115,15 @@ Show a diff of uncommitted changes.
 
 Show the commit log.
 
+=item grep pattern
+
+Searches for a pattern in each repository using the grep subcommand. Uses
+ack-grep on VCS that do not have their own.
+
+=item run command [param ...]
+
+Runs the specified command in each repository.
+
 =back
 
 These commands are also available:
@@ -106,8 +132,10 @@ These commands are also available:
 
 =item bootstrap url [directory]
 
-Causes mr to download the url, and use it as a .mrconfig file
-to checkout the repositories listed in it, into the specified directory.
+Causes mr to download the url, and use it as a .mrconfig file to checkout
+the repositories listed in it, into the specified directory.
+
+To use scp to download, the url may have the form ssh://[user@]host:file
 
 The directory will be created if it does not exist. If no directory is
 specified, the current directory will be used.
@@ -126,7 +154,7 @@ repository in the current directory is registered, or you can specify a
 directory to register.
 
 The mrconfig file that is modified is chosen by either the -c option, or by
-looking for the closest known one at or below the current directory.
+looking for the closest known one at or in a parent of the current directory.
 
 =item config
 
@@ -147,8 +175,8 @@ To see the built-in library of shell functions contained in mr:
 
   mr config DEFAULT lib
 
-The ~/.mrconfig file is used by default. To use a different config file,
-use the -c option.
+The mrconfig file that is used is chosen by either the -c option, or by
+looking for the closest known one at or in a parent of the current directory.
 
 =item offline
 
@@ -179,8 +207,8 @@ Actions can be abbreviated to any unambiguous substring, so
 update"
 
 Additional parameters can be passed to most commands, and are passed on
-unchanged to the underlying revision control system. This is mostly useful
-if the repositories mr will act on all use the same revision control
+unchanged to the underlying version control system. This is mostly useful
+if the repositories mr will act on all use the same version control
 system.
 
 =head1 OPTIONS
@@ -198,14 +226,16 @@ the current working directory.
 
 =item --config mrconfig
 
-Use the specified mrconfig file. The default is B<~/.mrconfig>
+Use the specified mrconfig file. The default is to use both F<~/.mrconfig>
+as well as look for a F<.mrconfig> file in the current directory, or in one
+of its parent directories.
 
-=item -p
+=item -f
 
-=item --path
+=item --force
 
-Search in the current directory, and its parent directories and use
-the first B<.mrconfig> found, instead of the default B<~/.mrconfig>.
+Force mr to act on repositories that would normally be skipped due to their
+configuration.
 
 =item -v
 
@@ -217,7 +247,9 @@ Be verbose.
 
 =item --quiet
 
-Be quiet.
+Be quiet. This suppresses mr's usual output, as well as any output from
+commands that are run (including stderr output). If a command fails,
+the output will be shown.
 
 =item -k
 
@@ -267,17 +299,23 @@ a good speedup in updates without loading the machine too much.
 
 =item --trust-all
 
-Trust all mrconfig files even if they are not listed in ~/.mrtrust.
+Trust all mrconfig files even if they are not listed in F<~/.mrtrust>.
 Use with caution.
 
+=item -p
+
+=item --path
+
+This obsolete flag is ignored.
+
 =back
 
-=head1 "MRCONFIG FILES"
+=head1 MRCONFIG FILES
 
-Here is an example .mrconfig file:
+Here is an example F<.mrconfig> file:
 
   [src]
-  checkout = svn co svn://svn.example.com/src/trunk src
+  checkout = svn checkout svn://svn.example.com/src/trunk src
   chain = true
 
   [src/linux-2.6]
@@ -285,14 +323,14 @@ Here is an example .mrconfig file:
        cd linux-2.6 &&
        git checkout -b mybranch origin/master
 
-The .mrconfig file uses a variant of the INI file format. Lines starting with
-"#" are comments. Values can be continued to the following line by
-indenting the line with whitespace.
+The F<.mrconfig> file uses a variant of the INI file format. Lines
+starting with "#" are comments. Values can be continued to the
+following line by indenting the line with whitespace.
 
-The "DEFAULT" section allows setting default values for the sections that
+The C<DEFAULT> section allows setting default values for the sections that
 come after it.
 
-The "ALIAS" section allows adding aliases for actions. Each parameter
+The C<ALIAS> section allows adding aliases for actions. Each parameter
 is an alias, and its value is the action to use.
 
 All other sections add repositories. The section header specifies the
@@ -300,27 +338,34 @@ directory where the repository is located. This is relative to the directory
 that contains the mrconfig file, but you can also choose to use absolute
 paths. (Note that you can use environment variables in section names; they
 will be passed through the shell for expansion. For example, 
-"[$HOSTNAME]", or "[${HOSTNAME}foo]")
+C<[$HOSTNAME]>, or C<[${HOSTNAME}foo]>).
 
 Within a section, each parameter defines a shell command to run to handle a
 given action. mr contains default handlers for "update", "status",
-"commit", and other standard actions. Normally you only need to specify what
-to do for "checkout".
+"commit", and other standard actions.
+
+Normally you only need to specify what to do for "checkout". Here you
+specify the command to run in order to create a checkout of the repository.
+The command will be run in the parent directory, and must create the
+repository's directory. So use C<git clone>, C<svn checkout>, C<bzr branch>
+or C<bzr checkout> (for a bound branch), etc.
 
-Note that these shell commands are run in a "set -e" shell
+Note that these shell commands are run in a C<set -e> shell
 environment, where any additional parameters you pass are available in
-"$@". The "checkout" command is run in the parent of the repository
-directory, since the repository isn't checked out yet. All other commands
-are run inside the repository, though not necessarily at the top of it.
+C<$@>. All commands other than "checkout" are run inside the repository,
+though not necessarily at the top of it.
 
-The "MR_REPO" environment variable is set to the path to the top of the
+The C<MR_REPO> environment variable is set to the path to the top of the
 repository. (For the "register" action, "MR_REPO" is instead set to the 
 basename of the directory that should be created when checking the
 repository out.)
 
-The "MR_CONFIG" environment variable is set to the .mrconfig file
+The C<MR_CONFIG> environment variable is set to the .mrconfig file
 that defines the repo being acted on, or, if the repo is not yet in a config
-file, the .mrconfig file that should be modified to register the repo.
+file, the F<.mrconfig> file that should be modified to register the repo.
+
+The C<MR_ACTION> environment variable is set to the command being run
+(update, checkout, etc).
 
 A few parameters have special meanings:
 
@@ -330,15 +375,28 @@ A few parameters have special meanings:
 
 If the "skip" parameter is set and its command returns true, then B<mr>
 will skip acting on that repository. The command is passed the action
-name in $1.
+name in C<$1>.
 
 Here are two examples. The first skips the repo unless
 mr is run by joey. The second uses the hours_since function
 (included in mr's built-in library) to skip updating the repo unless it's
 been at least 12 hours since the last update.
 
+  [mystuff]
+  checkout = ...
   skip = test `whoami` != joey
+
+  [linux]
+  checkout = ...
   skip = [ "$1" = update ] && ! hours_since "$1" 12
+Another way to use skip is for a lazy checkout. This makes mr skip
+operating on a repo unless it already exists. To enable the 
+repo, you have to explicitly check it out (using "mr --force -d foo checkout").
+
+  [foo]
+  checkout = ...
+  skip = lazy
 
 =item order
 
@@ -353,7 +411,7 @@ repository, ordering it to be processed earlier is not recommended.
 =item chain
 
 If the "chain" parameter is set and its command returns true, then B<mr>
-will try to load a .mrconfig file from the root of the repository.
+will try to load a F<.mrconfig> file from the root of the repository.
 
 =item include
 
@@ -364,60 +422,111 @@ part of the including file.
 Unlike all other parameters, this parameter does not need to be placed
 within a section.
 
+B<mr> ships several libraries that can be included to add support for
+additional version control type things (unison, git-svn, git-fake-bare,
+git-subtree). To include them all, you could use:
+
+  include = cat /usr/share/mr/*
+
+See the individual files for details.
+
+=item deleted
+
+If the "deleted" parameter is set and its command returns true, then
+B<mr> will treat the repository as deleted. It won't ever actually delete
+the repository, but it will warn if it sees the repository's directory.
+This is useful when one mrconfig file is shared among multiple machines,
+to keep track of and remember to delete old repositories.
+
 =item lib
 
-The "lib" parameter can specify some shell code that will be run before each
-command, this can be a useful way to define shell functions for other commands
-to use.
+The "lib" parameter can specify some shell code that will be run
+before each command, this can be a useful way to define shell
+functions for other commands to use. 
 
-=back
+Unlike most other parameters, this can be specified multiple times, in
+which case the chunks of shell code are accumulatively concatenated
+together.
+
+=item fixups
+
+If the "fixups" parameter is set, its command is run whenever a repository
+is checked out, or updated. This provides an easy way to do things
+like permissions fixups, or other tweaks to the repository content,
+whenever the repository is changed.
+
+=item VCS_action
 
 When looking for a command to run for a given action, mr first looks for
 a parameter with the same name as the action. If that is not found, it
-looks for a parameter named "rcs_action" (substituting in the name of the
-revision control system and the action). The name of the revision control
-system is itself determined by running each defined "rcs_test" action,
-until one succeeds.
+looks for a parameter named "VCS_action" (substituting in the name of the
+version control system and the action).
 
 Internally, mr has settings for "git_update", "svn_update", etc. To change
-the action that is performed for a given revision control system, you can
-override these rcs specific actions. To add a new revision control system,
-you can just add rcs specific actions for it.
+the action that is performed for a given version control system, you can
+override these VCS specific actions. To add a new version control system,
+you can just add VCS specific actions for it.
 
-The ~/.mrlog file contains commands that mr has remembered to run later,
-due to being offline. You can delete or edit this file to remove commands,
-or even to add other commands for 'mr online' to run. If the file is
-present, mr assumes it is in offline mode.
+=item pre_ and post_
+
+If a "pre_action" parameter is set, its command is run before mr performs the
+specified action. Similarly, "post_action" parameters are run after mr
+successfully performs the specified action. For example, "pre_commit" is
+run before committing; "post_update" is run after updating.
+
+=item _append
+
+Any parameter can be suffixed with C<_append>, to add an additional value
+to the existing value of the parameter. In this way, actions 
+can be constructed accumulatively.
+
+=item VCS_test
 
-=head1 "UNTRUSTED MRCONFIG FILES"
+The name of the version control system is itself determined by
+running each defined "VCS_test" action, until one succeeds.
+
+=back
+
+=head1 UNTRUSTED MRCONFIG FILES
 
 Since mrconfig files can contain arbitrary shell commands, they can do
-anything. This flexability is good, but it also allows a malicious mrconfig
+anything. This flexibility is good, but it also allows a malicious mrconfig
 file to delete your whole home directory. Such a file might be contained
-inside a repository that your main ~/.mrconfig checks out and chains to. To
-avoid worries about evil commands in a mrconfig file, mr
-has the ability to read mrconfig files in untrusted mode. Such files are
-limited to running only known safe commands (like "git clone") in a
-carefully checked manner.
+inside a repository that your main F<~/.mrconfig> checks out. To
+avoid worries about evil commands in a mrconfig file, mr defaults to
+reading all mrconfig files other than the main F<~/.mrconfig> in untrusted
+mode. In untrusted mode, mrconfig files are limited to running only known
+safe commands (like "git clone") in a carefully checked manner.
 
-By default, mr trusts all mrconfig files. (This default will change in a
-future release!) But if you have a ~/.mrtrust file, mr will only trust
-mrconfig files that are listed within it. (One file per line.) All other
-files will be treated as untrusted.
+To configure mr to trust other mrconfig files, list them in F<~/.mrtrust>.
+One mrconfig file should be listed per line. Either the full pathname
+should be listed, or the pathname can start with F<~/> to specify a file
+relative to your home directory.
+
+=head1 OFFLINE LOG FILE
+
+The F<~/.mrlog> file contains commands that mr has remembered to run later,
+due to being offline. You can delete or edit this file to remove commands,
+or even to add other commands for 'mr online' to run. If the file is
+present, mr assumes it is in offline mode.
 
 =head1 EXTENSIONS
 
 mr can be extended to support things such as unison and git-svn. Some
-files providing such extensions are available in /usr/share/mr/. See
+files providing such extensions are available in F</usr/share/mr/>. See
 the documentation in the files for details about using them.
 
+=head1 EXIT STATUS
+
+mr returns nonzero if a command failed in any of the repositories.
+
 =head1 AUTHOR
 
-Copyright 2007-2009 Joey Hess <joey@kitenet.net>
+Copyright 2007-2011 Joey Hess <joey@kitenet.net>
 
 Licensed under the GNU GPL version 2 or higher.
 
-http://kitenet.net/~joey/code/mr/
+http://myrepos.branchable.com/
 
 =cut
 
@@ -439,6 +548,7 @@ my $config_overridden=0;
 my $verbose=0;
 my $quiet=0;
 my $stats=0;
+my $force=0;
 my $insecure=0;
 my $interactive=0;
 my $max_depth;
@@ -446,7 +556,9 @@ my $no_chdir=0;
 my $jobs=1;
 my $trust_all=0;
 my $directory=getcwd();
-$ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
+
+my $HOME_MR_CONFIG = "$ENV{HOME}/.mrconfig";
+$ENV{MR_CONFIG}=find_mrconfig();
 
 # globals :-(
 my %config;
@@ -457,41 +569,106 @@ my (@ok, @failed, @skipped);
 
 main();
 
-my %rcs;
-sub rcs_test {
+sub shellquote {
+       my $i=shift;
+       $i=~s/'/'"'"'/g;
+       return "'$i'";
+}
+
+# Runs a shell command using a supplied function.
+# The lib will be included in the shell command line, and any params
+# will be available in the shell as $1, $2, etc.
+my $lastlib;
+sub runsh {
+       my ($action, $topdir, $subdir, $command, $params, $runner) = @_;
+
+       # optimisation: avoid running the shell for true and false
+       if ($command =~ /^\s*true\s*$/) {
+               $?=0;
+               return 0;
+       }
+       elsif ($command =~ /^\s*false\s*$/) {
+               $?=0;
+               return 1;
+       }
+       
+       my $quotedparams=join(" ", (map { shellquote($_) } @$params));
+       my $lib=exists $config{$topdir}{$subdir}{lib} ?
+                      $config{$topdir}{$subdir}{lib}."\n" : "";
+       if ($verbose && (! defined $lastlib || $lastlib ne $lib)) {
+               print "mr library now: >>$lib<<\n";
+               $lastlib=$lib;
+       }
+       my $shellcode="set -e;".$lib.
+               "my_sh(){ $command\n }; my_sh $quotedparams";
+       print "mr $action: running $action >>$command<<\n" if $verbose;
+       $runner->($shellcode);
+}
+
+my %perl_cache;
+sub perl {
+       my $id=shift;
+       my $s=shift;
+       if ($s =~ m/^perl:\s+(.*)/s) {
+               return $perl_cache{$1} if exists $perl_cache{$1};
+               my $sub=eval "sub {$1}";
+               if (! defined $sub) {
+                       print STDERR "mr: bad perl code in $id: $@\n";
+               }
+               return $perl_cache{$1} = $sub;
+       }
+       return undef;
+}
+
+my %vcs;
+sub vcs_test {
        my ($action, $dir, $topdir, $subdir) = @_;
 
-       if (exists $rcs{$dir}) {
-               return $rcs{$dir};
+       if (exists $vcs{$dir}) {
+               return $vcs{$dir};
        }
 
-       my $test="set -e\n";
-       foreach my $rcs_test (
+       my $test="";
+       my %perltest;
+       foreach my $vcs_test (
                        sort {
                                length $a <=> length $b 
                                          ||
                                       $a cmp $b
                        } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
-               my ($rcs)=$rcs_test=~/(.*)_test/;
-               $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
-               $test.="if my_$rcs_test; then echo $rcs; fi\n";
+               my ($vcs)=$vcs_test =~ /(.*)_test/;
+               my $p=perl($vcs_test, $config{$topdir}{$subdir}{$vcs_test});
+               if (defined $p) {
+                       $perltest{$vcs}=$p;
+               }
+               else {
+                       $test="my_$vcs_test() {\n$config{$topdir}{$subdir}{$vcs_test}\n}\n".$test;
+                       $test.="if my_$vcs_test; then echo $vcs; fi\n";
+               }
        }
-       $test=$config{$topdir}{$subdir}{lib}."\n".$test
-               if exists $config{$topdir}{$subdir}{lib};
-       
-       print "mr $action: running rcs test >>$test<<\n" if $verbose;
-       my $rcs=`$test`;
-       chomp $rcs;
-       if ($rcs=~/\n/s) {
-               $rcs=~s/\n/, /g;
-               print STDERR "mr $action: found multiple possible repository types ($rcs) for $topdir$subdir\n";
+
+       my @vcs;
+       foreach my $vcs (keys %perltest) {
+               if ($perltest{$vcs}->()) {
+                       push @vcs, $vcs;
+               }
+       }
+
+       push @vcs, split(/\n/,
+               runsh("vcs test", $topdir, $subdir, $test, [], sub {
+                       my $sh=shift;
+                       my $ret=`$sh`;
+                       return $ret;
+               })) if length $test;
+       if (@vcs > 1) {
+               print STDERR "mr $action: found multiple possible repository types (@vcs) for ".fulldir($topdir, $subdir)."\n";
                return undef;
        }
-       if (! length $rcs) {
-               return $rcs{$dir}=undef;
+       if (! @vcs) {
+               return $vcs{$dir}=undef;
        }
        else {
-               return $rcs{$dir}=$rcs;
+               return $vcs{$dir}=$vcs[0];
        }
 }
        
@@ -506,28 +683,68 @@ sub findcommand {
                return undef;
        }
 
-       my $rcs=rcs_test(@_);
+       my $vcs=vcs_test(@_);
 
-       if (defined $rcs && 
-           exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
-               return $config{$topdir}{$subdir}{$rcs."_".$action};
+       if (defined $vcs && 
+           exists $config{$topdir}{$subdir}{$vcs."_".$action}) {
+               return $config{$topdir}{$subdir}{$vcs."_".$action};
        }
        else {
                return undef;
        }
 }
 
+sub fulldir {
+       my ($topdir, $subdir) = @_;
+       return $subdir =~ /^\// ? $subdir : $topdir.$subdir;
+}
+
 sub action {
        my ($action, $dir, $topdir, $subdir, $force_checkout) = @_;
-       
+       my $fulldir=fulldir($topdir, $subdir);
+       my $checkout_dir;
+
        $ENV{MR_CONFIG}=$configfiles{$topdir};
-       my $lib=exists $config{$topdir}{$subdir}{lib} ?
-                      $config{$topdir}{$subdir}{lib}."\n" : "";
        my $is_checkout=($action eq 'checkout');
+       my $is_update=($action =~ /update/);
 
-       $ENV{MR_REPO}=$dir;
+       ($ENV{MR_REPO}=$dir) =~ s!/$!!;
+       $ENV{MR_ACTION}=$action;
+       
+       foreach my $testname ("skip", "deleted") {
+               next if $force && $testname eq "skip";
+
+               my $testcommand=findcommand($testname, $dir, $topdir, $subdir, $is_checkout);
+
+               if (defined $testcommand) {
+                       my $ret=runsh "$testname test", $topdir, $subdir,
+                               $testcommand, [$action],
+                               sub { system(shift()) };
+                       if ($ret != 0) {
+                               if (($? & 127) == 2) {
+                                       print STDERR "mr $action: interrupted\n";
+                                       return ABORT;
+                               }
+                               elsif ($? & 127) {
+                                       print STDERR "mr $action: $testname test received signal ".($? & 127)."\n";
+                                       return ABORT;
+                               }
+                       }
+                       if ($ret >> 8 == 0) {
+                               if ($testname eq "deleted") {
+                                       if (-d $dir) {
+                                               print STDERR "mr error: $dir should be deleted yet still exists\n";
+                                               return FAILED;
+                                       }
+                               }
+                               print "mr $action: skip $dir skipped\n" if $verbose;
+                               return SKIPPED;
+                       }
+               }
+       }
 
        if ($is_checkout) {
+               $checkout_dir=$dir;
                if (! $force_checkout) {
                        if (-d $dir) {
                                print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
@@ -537,36 +754,14 @@ sub action {
                        $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
                }
        }
-       elsif ($action =~ /update/) {
+       elsif ($is_update) {
                if (! -d $dir) {
                        return action("checkout", $dir, $topdir, $subdir);
                }
        }
 
-       my $skiptest=findcommand("skip", $dir, $topdir, $subdir, $is_checkout);
        my $command=findcommand($action, $dir, $topdir, $subdir, $is_checkout);
 
-       if (defined $skiptest) {
-               my $test="set -e;".$lib.
-                       "my_action(){ $skiptest\n }; my_action '$action'";
-               print "mr $action: running skip test >>$test<<\n" if $verbose;
-               my $ret=system($test);
-               if ($ret != 0) {
-                       if (($? & 127) == 2) {
-                               print STDERR "mr $action: interrupted\n";
-                               return ABORT;
-                       }
-                       elsif ($? & 127) {
-                               print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
-                               return ABORT;
-                       }
-               }
-               if ($ret >> 8 == 0) {
-                       print "mr $action: $dir skipped per config file\n" if $verbose;
-                       return SKIPPED;
-               }
-       }
-
        if ($is_checkout && ! -d $dir) {
                print "mr $action: creating parent directory $dir\n" if $verbose;
                system("mkdir", "-p", $dir);
@@ -577,30 +772,47 @@ sub action {
                return FAILED;
        }
        elsif (! defined $command) {
-               my $rcs=rcs_test(@_);
-               if (! defined $rcs) {
-                       print STDERR "mr $action: unknown repository type and no defined $action command for $topdir$subdir\n";
+               my $vcs=vcs_test(@_);
+               if (! defined $vcs) {
+                       print STDERR "mr $action: unknown repository type and no defined $action command for $fulldir\n";
                        return FAILED;
                }
                else {
-                       print STDERR "mr $action: no defined action for $rcs repository $topdir$subdir, skipping\n";
+                       print STDERR "mr $action: no defined action for $vcs repository $fulldir, skipping\n";
                        return SKIPPED;
                }
        }
        else {
+               my $actionmsg;
                if (! $no_chdir) {
-                       print "mr $action: $topdir$subdir\n" unless $quiet;
+                       $actionmsg="mr $action: $fulldir";
                }
                else {
                        my $s=$directory;
-                       $s=~s/^\Q$topdir$subdir\E\/?//;
-                       print "mr $action: $topdir$subdir (in subdir $s)\n" unless $quiet;
+                       $s=~s/^\Q$fulldir\E\/?//;
+                       $actionmsg="mr $action: $fulldir (in subdir $s)";
                }
-               $command="set -e; ".$lib.
-                       "my_action(){ $command\n }; my_action ".
-                       join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
-               print "mr $action: running >>$command<<\n" if $verbose;
-               my $ret=system($command);
+               print "$actionmsg\n" unless $quiet;
+
+               my $hookret=hook("pre_$action", $topdir, $subdir);
+               return $hookret if $hookret != OK;
+
+               my $ret=runsh $action, $topdir, $subdir,
+                       $command, \@ARGV, sub {
+                               my $sh=shift;
+                               if ($quiet) {
+                                       my $output = qx/$sh 2>&1/;
+                                       my $ret = $?;
+                                       if ($ret != 0) {
+                                               print "$actionmsg\n";
+                                               print STDERR $output;
+                                       }
+                                       return $ret;
+                               }
+                               else {
+                                       system($sh);
+                               }
+                       };
                if ($ret != 0) {
                        if (($? & 127) == 2) {
                                print STDERR "mr $action: interrupted\n";
@@ -628,16 +840,66 @@ sub action {
                        return FAILED;
                }
                else {
-                       if ($action eq 'checkout' && ! -d $dir) {
+                       if ($is_checkout && ! -d $dir) {
                                print STDERR "mr $action: $dir missing after checkout\n";;
                                return FAILED;
                        }
 
+                       my $ret=hook("post_$action", $topdir, $subdir);
+                       return $ret if $ret != OK;
+                       
+                       if ($is_checkout || $is_update) {
+                               if ($is_checkout && ! $no_chdir) {
+                                       if (! chdir($checkout_dir)) {
+                                               print STDERR "mr $action: failed to chdir to $checkout_dir: $!\n";
+                                               return FAILED;
+                                       }
+                               }
+                               my $ret=hook("fixups", $topdir, $subdir);
+                               return $ret if $ret != OK;
+                       }
+                       
                        return OK;
                }
        }
 }
 
+sub hook {
+       my ($hook, $topdir, $subdir) = @_;
+
+       my $command=$config{$topdir}{$subdir}{$hook};
+       return OK unless defined $command;
+       my $ret=runsh $hook, $topdir, $subdir, $command, [], sub {
+                       my $sh=shift;
+                       if ($quiet) {
+                               my $output = qx/$sh 2>&1/;
+                               my $ret = $?;
+                               if ($ret != 0) {
+                                       print STDERR $output;
+                               }
+                               return $ret;
+                       }
+                       else {
+                               system($sh);
+                       }
+               };
+       if ($ret != 0) {
+               if (($? & 127) == 2) {
+                       print STDERR "mr $hook: interrupted\n";
+                       return ABORT;
+               }
+               elsif ($? & 127) {
+                       print STDERR "mr $hook: received signal ".($? & 127)."\n";
+                       return ABORT;
+               }
+               else {
+                       return FAILED;
+               }
+       }
+
+       return OK;
+}
+
 # run actions on multiple repos, in parallel
 sub mrs {
        my $action=shift;
@@ -796,7 +1058,10 @@ sub repodir {
        return $ret;
 }
 
-# figure out which repos to act on
+# Figure out which repos to act on.  Returns a list of array refs
+# in the format:
+#
+#   [ "$full_repo_path/", "$mr_config_path/", $section_header ]
 sub selectrepos {
        my @repos;
        foreach my $repo (repolist()) {
@@ -855,28 +1120,22 @@ sub is_trusted_config {
        my $config=shift; # must be abs_pathed already
 
        # We always trust ~/.mrconfig.
-       return 1 if $config eq abs_path("$ENV{HOME}/.mrconfig");
+       return 1 if $config eq abs_path($HOME_MR_CONFIG);
 
        return 1 if $trust_all;
 
        my $trustfile=$ENV{HOME}."/.mrtrust";
 
-       if (! -e $trustfile) {
-               print "mr: Assuming $config is trusted.\n";
-               print "mr: For better security, you are encouraged to create ~/.mrtrust\n";
-               print "mr: and list all trusted mrconfig files in it.\n";
-               return 1;
-       }
-
        if (! %trusted) {
-               $trusted{"$ENV{HOME}/.mrconfig"}=1;
-               open (TRUST, "<", $trustfile) || die "$trustfile: $!";
-               while (<TRUST>) {
-                       chomp;
-                       s/^~\//$ENV{HOME}\//;
-                       $trusted{abs_path($_)}=1;
+               $trusted{$HOME_MR_CONFIG}=1;
+               if (open (TRUST, "<", $trustfile)) {
+                       while (<TRUST>) {
+                               chomp;
+                               s/^~\//$ENV{HOME}\//;
+                               $trusted{abs_path($_)}=1;
+                       }
+                       close TRUST;
                }
-               close TRUST;
        }
 
        return $trusted{$config};
@@ -947,7 +1206,7 @@ sub is_trusted_checkout {
                                        is_trusted_repo($words[$c])
                                );
                        }
-                       elsif (defined $words[$c] && $twords[$c] eq $words[$c]) {
+                       elsif (defined $words[$c] && $words[$c]=~/^($twords[$c])$/) {
                                $match=1;
                        }
                        else {
@@ -964,6 +1223,7 @@ my %loaded;
 sub loadconfig {
        my $f=shift;
        my $dir=shift;
+       my $bootstrap_url=shift;
 
        my @toload;
 
@@ -975,10 +1235,6 @@ sub loadconfig {
                $trusted=1;
        }
        else {
-               if (! -e $f) {
-                       return;
-               }
-
                my $absf=abs_path($f);
                if ($loaded{$absf}) {
                        return;
@@ -1013,6 +1269,10 @@ sub loadconfig {
                        }
                }
                
+               if (! -e $f) {
+                       return;
+               }
+
                print "mr: loading config $f\n" if $verbose;
                open($in, "<", $f) || die "mr: open $f: $!\n";
        }
@@ -1020,12 +1280,57 @@ sub loadconfig {
        close $in unless ref $f eq 'GLOB';
 
        my $section;
-       my $line=0;
+
+       # Keep track of the current line in the config file;
+       # when a file is included track the current line from the include.
+       my $lineno=0;
+       my $included=undef;
+
+       my $line;
+       my $nextline = sub {
+               if ($included) {
+                       $included--;
+               }
+               else {
+                       $included=undef;
+                       $lineno++;
+               }
+               $line=shift @lines;
+               chomp $line;
+               return $line;
+       };
+       my $lineerror = sub {
+               my $msg=shift;
+               if (defined $included) {
+                       die "mr: $msg at $f line $lineno, included line: $line\n";
+               }
+               else {
+                       die "mr: $msg at $f line $lineno\n";
+               }
+       };
+       my $trusterror = sub {
+               my $msg=shift;
+       
+               if (defined $bootstrap_url) {
+                       die "mr: $msg in untrusted $bootstrap_url line $lineno\n".
+                               "(To trust this url, --trust-all can be used; but please use caution;\n".
+                               "this can allow arbitrary code execution!)\n";
+               }
+               else {
+                       die "mr: $msg in untrusted $f line $lineno\n".
+                               "(To trust this file, list it in ~/.mrtrust.)\n";
+               }
+       };
+
        while (@lines) {
-               $_=shift @lines;
-               $line++;
-               chomp;
+               $_=$nextline->();
+
                next if /^\s*\#/ || /^\s*$/;
+
+               if (! $trusted && /[[:cntrl:]]/) {
+                       $trusterror->("illegal control character");
+               }
+
                if (/^\[([^\]]*)\]\s*$/) {
                        $section=$1;
 
@@ -1033,7 +1338,7 @@ sub loadconfig {
                                if (! is_trusted_repo($section) ||
                                    $section eq 'ALIAS' ||
                                    $section eq 'DEFAULT') {
-                                       die "mr: illegal section \"[$section]\" in untrusted $f line $line\n";
+                                       $trusterror->("illegal section \"[$section]\"");
                                }
                        }
                        $section=expandenv($section) if $trusted;
@@ -1050,40 +1355,51 @@ sub loadconfig {
 
                        # continued value
                        while (@lines && $lines[0]=~/^\s(.+)/) {
-                               shift(@lines);
-                               $line++;
                                $value.="\n$1";
                                chomp $value;
+                               $nextline->();
                        }
 
                        if (! $trusted) {
-                               # Untrusted files can only contain checkout
-                               # parameters.
-                               if ($parameter ne 'checkout') {
-                                       die "mr: illegal setting \"$parameter=$value\" in untrusted $f line $line\n";
+                               # Untrusted files can only contain a few
+                               # settings in specific known-safe formats.
+                               if ($parameter eq 'checkout') {
+                                       if (! is_trusted_checkout($value)) {
+                                               $trusterror->("illegal checkout command \"$value\"");
+                                       }
+                               }
+                               elsif ($parameter eq 'order') {
+                                       # not interpreted as a command, so
+                                       # safe.
                                }
-                               if (! is_trusted_checkout($value)) {
-                                       die "mr: illegal checkout command \"$value\" in untrusted $f line $line\n";
+                               elsif ($value eq 'true' || $value eq 'false') {
+                                       # skip=true , deleted=true etc are
+                                       # safe.
+                               }
+                               else {
+                                       $trusterror->("illegal setting \"$parameter=$value\"");
                                }
                        }
 
                        if ($parameter eq "include") {
                                print "mr: including output of \"$value\"\n" if $verbose;
-                               unshift @lines, `$value`;
+                               my @inc=`$value`;
                                if ($?) {
                                        print STDERR "mr: include command exited nonzero ($?)\n";
                                }
+                               $included += @inc;
+                               unshift @lines, @inc;
                                next;
                        }
 
                        if (! defined $section) {
-                               die "$f line $.: parameter ($parameter) not in section\n";
+                               $lineerror->("parameter ($parameter) not in section");
                        }
                        if ($section eq 'ALIAS') {
                                $alias{$parameter}=$value;
                        }
-                       elsif ($parameter eq 'lib') {
-                               $config{$dir}{$section}{lib}.=$value."\n";
+                       elsif ($parameter eq 'lib' or $parameter =~ s/_append$//) {
+                               $config{$dir}{$section}{$parameter}.="\n".$value."\n";
                        }
                        else {
                                $config{$dir}{$section}{$parameter}=$value;
@@ -1094,31 +1410,36 @@ sub loadconfig {
                                        $knownactions{$parameter}=1;
                                }
                                if ($parameter eq 'chain' &&
-                                   length $dir && $section ne "DEFAULT" &&
-                                   -e $dir.$section."/.mrconfig") {
-                                       my $ret=system($value);
-                                       if ($ret != 0) {
-                                               if (($? & 127) == 2) {
-                                                       print STDERR "mr: chain test interrupted\n";
-                                                       exit 2;
+                                   length $dir && $section ne "DEFAULT") {
+                                       my $chaindir="$section";
+                                       if ($chaindir !~ m!^/!) {
+                                               $chaindir=$dir.$chaindir;
+                                       }
+                                       if (-e "$chaindir/.mrconfig") {
+                                               my $ret=system($value);
+                                               if ($ret != 0) {
+                                                       if (($? & 127) == 2) {
+                                                               print STDERR "mr: chain test interrupted\n";
+                                                               exit 2;
+                                                       }
+                                                       elsif ($? & 127) {
+                                                               print STDERR "mr: chain test received signal ".($? & 127)."\n";
+                                                       }
                                                }
-                                               elsif ($? & 127) {
-                                                       print STDERR "mr: chain test received signal ".($? & 127)."\n";
+                                               else {
+                                                       push @toload, ["$chaindir/.mrconfig", $chaindir];
                                                }
                                        }
-                                       else {
-                                               push @toload, $dir.$section."/.mrconfig";
-                                       }
                                }
                        }
                }
                else {
-                       die "$f line $line: parse error\n";
+                       $lineerror->("parse error");
                }
        }
 
-       foreach (@toload) {
-               loadconfig($_);
+       foreach my $c (@toload) {
+               loadconfig(@$c);
        }
 }
 
@@ -1342,29 +1663,49 @@ sub register {
        $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
        $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
                "my_action(){ $command\n }; my_action ".
-               join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
+               join(" ", map { s/\\/\\\\/g; s/"/\"/g; '"'.$_.'"' } @ARGV);
        print "mr register: running >>$command<<\n" if $verbose;
        exec($command) || die "exec: $!";
 }
 
 sub bootstrap {
+       eval q{use File::Copy};
+       die $@ if $@;
+
        my $url=shift @ARGV;
        my $dir=shift @ARGV || ".";
        
        if (! defined $url || ! length $url) {
                die "mr: bootstrap requires url\n";
        }
-       
-       # Download the config file to a temporary location.
+
+       # Retrieve config file.
        eval q{use File::Temp};
        die $@ if $@;
        my $tmpconfig=File::Temp->new();
-       my @curlargs = ("curl", "-A", "mr", "-L", "-s", $url, "-o", $tmpconfig);
-       push(@curlargs, "-k") if $insecure;
-       my $curlstatus = system(@curlargs);
-       die "mr bootstrap: invalid SSL certificate for $url (consider -k)\n" if $curlstatus >> 8 == 60;
-       die "mr bootstrap: download of $url failed\n" if $curlstatus != 0;
+       if ($url =~ m!^[\w\d]+://!) {
+               # Download the config file to a temporary location.
+               my @downloader;
+               if ($url =~ m!^ssh://(.*)!) {
+                       @downloader = ("scp", $1, $tmpconfig);
+               }
+               else {
+                       @downloader = ("curl", "-A", "mr", "-L", "-s", $url, "-o", $tmpconfig);
+                       push(@downloader, "-k") if $insecure;
+               }
+               my $status = system(@downloader);
+               die "mr bootstrap: invalid SSL certificate for $url (consider -k)\n"
+                       if $downloader[0] eq 'curl' && $status >> 8 == 60;
+               die "mr bootstrap: download of $url failed\n" if $status != 0;
+       }
+       else {
+               # Config file is local.
+               die "mr bootstrap: cannot read file '$url'"
+                       unless -r $url;
+               copy($url, $tmpconfig) || die "copy: $!";
+       }
 
+       # Sanity check on destination directory.
        if (! -e $dir) {
                system("mkdir", "-p", $dir);
        }
@@ -1374,7 +1715,7 @@ sub bootstrap {
        # would normally be skipped.
        my $topdir=abs_path(".")."/";
        my @repo=($topdir, $topdir, ".");
-       loadconfig($tmpconfig, $topdir);
+       loadconfig($tmpconfig, $topdir, $url);
        record(\@repo, action("checkout", @repo, 1))
                if exists $config{$topdir}{"."}{"checkout"};
 
@@ -1382,8 +1723,6 @@ sub bootstrap {
                print STDERR "mr bootstrap: .mrconfig file already exists, not overwriting with $url\n";
        }
        else {
-               eval q{use File::Copy};
-               die $@ if $@;
                move($tmpconfig, ".mrconfig") || die "rename: $!";
        }
 
@@ -1421,7 +1760,7 @@ sub expandaction {
        return $action;
 }
 
-sub find_nearest_mrconfig {
+sub find_mrconfig {
        my $dir=getcwd();
        while (length $dir) {
                if (-e "$dir/.mrconfig") {
@@ -1429,7 +1768,7 @@ sub find_nearest_mrconfig {
                }
                $dir=~s/\/[^\/]*$//;
        }
-       die "no .mrconfig found in path\n";
+       return $HOME_MR_CONFIG;
 }
 
 sub getopts {
@@ -1438,7 +1777,8 @@ sub getopts {
        my $result=GetOptions(
                "d|directory=s" => sub { $directory=abs_path($_[1]) },
                "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
-               "p|path" => sub { $ENV{MR_CONFIG}=find_nearest_mrconfig(); $config_overridden=1 },
+               "p|path" => sub { }, # now default, ignore
+               "f|force" => \$force,
                "v|verbose" => \$verbose,
                "q|quiet" => \$quiet,
                "s|stats" => \$stats,
@@ -1488,9 +1828,6 @@ sub exitstats {
        if (@failed) {
                exit 1;
        }
-       elsif (! @ok && @skipped) {
-               exit 1;
-       }
        else {
                exit 0;
        }
@@ -1501,6 +1838,7 @@ sub main {
        init();
 
        startingconfig();
+       loadconfig($HOME_MR_CONFIG);
        loadconfig($ENV{MR_CONFIG});
        #use Data::Dumper; print Dumper(\%config);
        
@@ -1536,7 +1874,7 @@ lib =
                if [ -z "$1" ] || [ -z "$2" ]; then
                        error "mr: usage: hours_since action num"
                fi
-               for dir in .git .svn .bzr CVS .hg _darcs; do
+               for dir in .git .svn .bzr CVS .hg _darcs _FOSSIL_; do
                        if [ -e "$MR_REPO/$dir" ]; then
                                flagfile="$MR_REPO/$dir/.mr_last$1"
                                break
@@ -1553,43 +1891,91 @@ lib =
                        return 0
                fi
        }
+       is_bzr_checkout() {
+               LANG=C bzr info | egrep -q '^Checkout'
+       }
+       lazy() {
+               if [ -d "$MR_REPO" ]; then
+                       return 1
+               else
+                       return 0
+               fi
+       }
 
-svn_test = test -d "$MR_REPO"/.svn
-git_test = test -d "$MR_REPO"/.git
-bzr_test = test -d "$MR_REPO"/.bzr
-cvs_test = test -d "$MR_REPO"/CVS
-hg_test  = test -d "$MR_REPO"/.hg
-darcs_test = test -d "$MR_REPO"/_darcs
-git_bare_test =
-       test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
-       test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
-       test "`GIT_CONFIG="$MR_REPO"/config git config --get core.bare`" = true
+svn_test = perl: -d "$ENV{MR_REPO}/.svn"
+git_test = perl: -e "$ENV{MR_REPO}/.git"
+bzr_test = perl: -d "$ENV{MR_REPO}/.bzr"
+cvs_test = perl: -d "$ENV{MR_REPO}/CVS"
+hg_test  = perl: -d "$ENV{MR_REPO}/.hg"
+darcs_test = perl: -d "$ENV{MR_REPO}/_darcs"
+fossil_test = perl: -f "$ENV{MR_REPO}/_FOSSIL_"
+git_bare_test = perl: 
+       -d "$ENV{MR_REPO}/refs/heads" && -d "$ENV{MR_REPO}/refs/tags" &&
+       -d "$ENV{MR_REPO}/objects" && -f "$ENV{MR_REPO}/config" &&
+       `GIT_CONFIG="$ENV{MR_REPO}"/config git config --get core.bare` =~ /true/
+vcsh_test = perl:
+       -d "$ENV{MR_REPO}/refs/heads" && -d "$ENV{MR_REPO}/refs/tags" &&
+       -d "$ENV{MR_REPO}/objects" && -f "$ENV{MR_REPO}/config" &&
+       `GIT_CONFIG="$ENV{MR_REPO}"/config git config --get vcsh.vcsh` =~ /true/
+veracity_test  = perl: -d "$ENV{MR_REPO}/.sgdrawer"
 
 svn_update = svn update "$@"
 git_update = git pull "$@"
-bzr_update = bzr merge --pull "$@"
-cvs_update = cvs update "$@"
-hg_update  = hg pull "$@" && hg update "$@"
+bzr_update = 
+       if is_bzr_checkout; then
+               bzr update "$@"
+       else
+               bzr merge --pull "$@"
+       fi
+cvs_update = cvs -q update "$@"
+hg_update  = hg pull "$@"; hg update "$@"
 darcs_update = darcs pull -a "$@"
+fossil_update = fossil pull "$@"
+vcsh_update = vcsh run "$MR_REPO" git pull "$@"
+veracity_update = vv pull "$@" && vv update "$@"
+
+git_fetch = git fetch --all --prune --tags
+git_svn_fetch = git svn fetch
+darcs_fetch = darcs fetch
+hg_fetch = hg pull
 
 svn_status = svn status "$@"
-git_status = git status "$@" || true
-bzr_status = bzr status "$@"
-cvs_status = cvs status "$@"
-hg_status  = hg status "$@"
+git_status = git status -s "$@" || true; git --no-pager log --branches --not --remotes --simplify-by-decoration --decorate --oneline || true
+bzr_status = bzr status --short "$@"; bzr missing
+cvs_status = cvs -q status | grep -E '^(File:.*Status:|\?)' | grep -v 'Status: Up-to-date'
+hg_status  = hg status "$@"; hg summary --quiet | grep -v 'parent: 0:'
 darcs_status = darcs whatsnew -ls "$@" || true
+fossil_status = fossil changes "$@"
+vcsh_status = vcsh run "$MR_REPO" git -c status.relativePaths=false status -s "$@" || true
+veracity_status = vv status "$@"
 
 svn_commit = svn commit "$@"
 git_commit = git commit -a "$@" && git push --all
-bzr_commit = bzr commit "$@" && bzr push
+bzr_commit = 
+       if is_bzr_checkout; then
+               bzr commit "$@"
+       else
+               bzr commit "$@" && bzr push
+       fi
 cvs_commit = cvs commit "$@"
-hg_commit  = hg commit -m "$@" && hg push
-darcs_commit = darcs record -a -m "$@" && darcs push -a
+hg_commit  = hg commit "$@" && hg push
+darcs_commit = darcs record -a "$@" && darcs push -a
+fossil_commit = fossil commit "$@"
+vcsh_commit = vcsh run "$MR_REPO" git commit -a "$@" && vcsh run "$MR_REPO" git push --all
+veracity_commit = vv commit "$@" && vv push
 
 git_record = git commit -a "$@"
-bzr_record = bzr commit "$@"
-hg_record  = hg commit -m "$@"
-darcs_record = darcs record -a -m "$@"
+bzr_record =
+       if is_bzr_checkout; then
+               bzr commit --local "$@"
+       else
+               bzr commit "$@"
+       fi
+hg_record  = hg commit "$@"
+darcs_record = darcs record -a "$@"
+fossil_record = fossil commit "$@"
+vcsh_record = vcsh run "$MR_REPO" git commit -a "$@"
+veracity_record = vv commit "$@"
 
 svn_push = :
 git_push = git push "$@"
@@ -1597,13 +1983,19 @@ bzr_push = bzr push "$@"
 cvs_push = :
 hg_push = hg push "$@"
 darcs_push = darcs push -a "$@"
+fossil_push = fossil push "$@"
+vcsh_push = vcsh run "$MR_REPO" git push "$@"
+veracity_push = vv push "$@"
 
 svn_diff = svn diff "$@"
 git_diff = git diff "$@"
 bzr_diff = bzr diff "$@"
-cvs_diff = cvs diff "$@"
+cvs_diff = cvs -q diff "$@"
 hg_diff  = hg diff "$@"
 darcs_diff = darcs diff -u "$@"
+fossil_diff = fossil diff "$@"
+vcsh_diff = vcsh run "$MR_REPO" git diff "$@"
+veracity_diff = vv diff "$@"
 
 svn_log = svn log "$@"
 git_log = git log "$@"
@@ -1612,6 +2004,18 @@ cvs_log = cvs log "$@"
 hg_log  = hg log "$@"
 darcs_log = darcs changes "$@"
 git_bare_log = git log "$@"
+fossil_log = fossil timeline "$@"
+vcsh_log = vcsh run "$MR_REPO" git log "$@"
+veracity_log = vv log "$@"
+
+hg_grep = hg grep "$@"
+cvs_grep = ack-grep "$@"
+svn_grep = ack-grep "$@"
+git_svn_grep = git grep "$@"
+git_grep = git grep "$@"
+bzr_grep = ack-grep "$@"
+
+run = "$@"
 
 svn_register =
        url=`LC_ALL=C svn info . | grep -i '^URL:' | cut -d ' ' -f 2`
@@ -1628,12 +2032,12 @@ git_register =
        echo "Registering git url: $url in $MR_CONFIG"
        mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
 bzr_register =
-       url="`LC_ALL=C bzr info . | egrep -i 'checkout of branch|parent branch' | awk '{print $NF}'`"
+       url="`LC_ALL=C bzr info . | egrep -i 'checkout of branch|parent branch' | awk '{print $NF}' | head -n 1`"
        if [ -z "$url" ]; then
                error "cannot determine bzr url"
        fi
        echo "Registering bzr url: $url in $MR_CONFIG"
-       mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone '$url' '$MR_REPO'"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr branch '$url' '$MR_REPO'"
 cvs_register =
        repo=`cat CVS/Repository`
        root=`cat CVS/Root`
@@ -1657,15 +2061,35 @@ git_bare_register =
        fi
        echo "Registering git url: $url in $MR_CONFIG"
        mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
+vcsh_register =
+       url="`LC_ALL=C vcsh run "$MR_REPO" git config --get remote.origin.url`" || true
+       if [ -z "$url" ]; then
+               error "cannot determine git url"
+       fi
+       echo "Registering git url: $url in $MR_CONFIG"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="vcsh clone '$url' '$MR_REPO'"
+fossil_register =
+       url=`fossil remote-url`
+       repo=`fossil info | grep repository | sed -e 's/repository:*.//g' -e 's/ //g'`
+       echo "Registering fossil repository $url in $MR_CONFIG"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="mkdir -p '$MR_REPO' && cd '$MR_REPO' && fossil open '$repo'"
+veracity_register =
+       url=`vv config | grep sync_targets | sed -e 's/sync_targets:*.//g' -e 's/ //g'`
+       repo=`vv repo info | grep repository | sed -e 's/Current repository:*.//g' -e 's/ //g'`
+       echo "Registering veracity repository $url in $MR_CONFIG"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="mkdir -p '$MR_REPO' && cd '$MR_REPO' && vv checkout '$repo'"
 
 svn_trusted_checkout = svn co $url $repo
 svn_alt_trusted_checkout = svn checkout $url $repo
 git_trusted_checkout = git clone $url $repo
-bzr_trusted_checkout = bzr clone $url $repo
+bzr_trusted_checkout = bzr checkout|clone|branch|get $url $repo
 # cvs: too hard
 hg_trusted_checkout = hg clone $url $repo
 darcs_trusted_checkout = darcs get $url $repo
 git_bare_trusted_checkout = git clone --bare $url $repo
+vcsh_trusted_checkout = vcsh run "$MR_REPO" git clone $url $repo
+# fossil: messy to do
+veracity_trusted_checkout = vv clone $url $repo
 
 
 help =
@@ -1677,7 +2101,7 @@ help =
                SHOWMANFILE="man"
                ;;
                *)
-               SHOWMANFILE="man -l"
+               SHOWMANFILE="man"
                ;;
        esac
        if [ ! -e "$MR_PATH" ]; then
@@ -1721,3 +2145,7 @@ T = echo "I pity the fool."
 right = echo "Not found."
 
 # vim:sw=8:sts=0:ts=8:noet
+# Local variables:
+# indent-tabs-mode: t
+# cperl-indent-level: 8
+# End: